UNIT mTNetzHW;

interface

//--------------------  ggf Uses-Liste einfgen !  --------------------
uses
  Windows,   // Comm-Funktionen
  SysUtils,  // IntToStr
  Dialogs;   // ShowMessage

type
   TNetzHW = CLASS

     // weitere Attribute
     private
        aus        : boolean;
        PortHandle : integer;

     // weitere Methoden
     public
        procedure SetAus (pAus: boolean); virtual;
        procedure Stop; virtual;
        function GetAus : boolean; virtual;
        function GetEin : boolean; virtual;
        procedure Start (nr: byte); virtual;
   end;

implementation

//+---------------------------------------------------------------------
//|         TNetzHW: Methodendefinition 
//+---------------------------------------------------------------------

//-------- SetAus (public) ---------------------------------------------
procedure TNetzHW.SetAus (pAus: boolean);
begin
  aus := pAus;
  if pAus
  then
    EscapeCommFunction(PortHandle,SETRTS)
  else
    EscapeCommFunction(PortHandle,CLRRTS);   
end;

//-------- Stop (public) -----------------------------------------------
procedure TNetzHW.Stop;
begin
  CloseHandle(PortHandle);
end;

//-------- GetAus (public) ---------------------------------------------
function TNetzHW.GetAus : boolean;
begin
  result := aus;
end;

//-------- GetEin (public) ---------------------------------------------
function TNetzHW.GetEin : boolean;
var
  ein : DWORD;
begin
  GetCommModemStatus(PortHandle,ein);
  if (ein and 16) > 0
  then result := true else result := false;
end;

//-------- Start (public) ----------------------------------------------
procedure TNetzHW.Start (nr: byte);
var
  res,error : integer;
  PortStr   : string;
begin
  PortStr := 'COM'+IntToStr(nr);
  res := CreateFile(PChar(PortStr),
                    GENERIC_READ or GENERIC_WRITE,
                    0,nil,OPEN_EXISTING,0,0);
  if res > 0
  then
  begin
    PortHandle := res;
    setAus(false);
  end
  else
  begin
    error := GetLastError;
    ShowMessage('Fehler: '+IntToStr(error));
  end;
end;

end.
